﻿<?php
/*
* 2007-2014 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2014 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

/**
 * @since 1.5.0
 */
class Cash24PaymentModuleFrontController extends ModuleFrontController
{
//	public $ssl = true;

	public $payment_system = 'cash24';

	public function __construct()
	{
		parent::__construct();

		$this->display_column_left = false;
	}

	/**
	 * @see FrontController::initContent()
	 */
	public function initContent()
	{
		parent::initContent();

		$cart = $this->context->cart;
		if (!$this->module->checkCurrency($cart))
			Tools::redirect('index.php?controller=order');

		global $cookie;

		$this->payment_system = Tools::getValue('payment_system', 'cash24');
		$payment_system = $this->module->_payment_systems[$this->payment_system];

		$customer = new Customer((int)$cookie->id_customer);
$id_address = Address::getFirstCustomerAddressId($cookie->id_customer);
$address = new Address($id_address);
              
		$currency = new Currency((int)($cart->id_currency));

		$amount = number_format($cart->getOrderTotal(true, 3), 2, '.', '');
				
 $time = time() + Configuration::get('CASH24_EXP') * 24 * 60 * 60;
  $exptime=gmdate('Y-m-d', $time) . 'T' . gmdate('H:i:s', $time);



$arParams = array();
$arParams['amount']=$amount;
$arParams['currency']='RUB';
$arParams['email']=$customer->email;
$arParams['description']='Order '.$cart->id;
$arParams['order']=(int)$cart->id;
$arParams['success']=htmlspecialchars('http://'.$this->module->host_url.__PS_BASE_URI__.'index.php?controller=order-confirmation&id_cart='.(int)($cart->id).'&id_module='.(int)($this->module->id).'&key='.$customer->secure_key.'&status=success');
$arParams['cancel']=htmlspecialchars('http://'.$this->module->host_url.__PS_BASE_URI__.'index.php?controller=order-confirmation&id_cart='.(int)($cart->id).'&id_module='.(int)($this->module->id).'&key='.$customer->secure_key.'&status=fail');
$arParams['callback']=htmlspecialchars('http://'.$this->module->host_url.__PS_BASE_URI__.'modules/cash24/callback.php');
$arParams['method']=$this->payment_system;
$arParams['phone']=$address->phone_mobile;
$arParams['wallet']='';
$arParams['expires']=$exptime;

	
               
     
$headers = array(
    "Content-type: text/xml"
    
);
$k= $this->createInvoice($arParams,Configuration::get('CASH24_MERCHANT_ID'),Configuration::get('CASH24_COMMAND_KEY'));

switch (Configuration::get('CASH24_TEST_MODE')) {
				case '1':
					$respurl="http://api.staging.cash24.ru/1.0/";
					break;
				case '0':
					$respurl="https://api.cash24.ru/1.0/";
					break;
			}

   $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $respurl);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER,true);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $k);
 curl_setopt($curl, CURLOPT_HTTPHEADER, $headers );
  
 curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
    $out = curl_exec($curl);
$url = simplexml_load_string($out);
 
$turl= $url;
 
  $url = $url->response->url; //формируем строку url

  if(!empty($turl->envelope->error)){
  
  
die($turl->envelope->text);
  
  }

$this->module->validateOrder($cart->id, Configuration::get('CASH24_OS_WAITING'), (float)($amount), $this->module->displayName, '', array(), NULL, false, $customer->secure_key);
		$this->context->smarty->assign('url', $url);
		

		$this->setTemplate('payment_execution.tpl');
	

	}
	
    private function createInvoice($arParams,$auth,$key)
 {
  
  $request = '';
  $toSign = 'create-invoice';
  foreach ($arParams as $c => $val)
  {
   $request .= "<$c>" . $val . "</$c>\r\n";
   if ($c != 'expires' AND $c != 'phone')
    $toSign .= '-' . $val;
  }

  $sign = md5(htmlspecialchars_decode($toSign) . '-' . $key);

  $xml = '
   <?xml version="1.0" encoding="utf-8"?>
   <cash24 xmlns="http://api.cash24.ru/1.0/">
     <request xmlns="http://api.cash24.ru/1.0/create-invoice/">
    ' . $request . '
     </request>
     <envelope>
    <auth>' . $auth . '</auth>
    <sign>' . $sign . '</sign>
     </envelope>
   </cash24>
  ';

  return trim($xml);
 }

}
